/*

 - - - ball-MI - - - 
 performing software
 by Eiichi Ishii
 推奨画面サイズ：1366×768
 
 */

import ddf.minim.*;

Minim minim;
AudioSample sound1;
AudioSample sound2;
AudioSample sound3;
AudioSample sound4;
AudioSample sound5;
AudioInput in;

PImage ic;
PImage logo;

Mtoggles mt;
Ntoggles nt;
Ctoggles ct;

float mainCW=255;
float mainCB=0;

int num1=10;
int num2=10;
int num3=10;
int num4=10;
int num5=10;
module1[]m1=new module1[num1];
module2[]m2=new module2[num2];
module3[]m3=new module3[num3];
module4[]m4=new module4[num4];
module5[]m5=new module5[num5];

void setup() {
  size(displayWidth, displayHeight);
  noSmooth();
  noCursor();
  textAlign(CENTER);

  ic = loadImage("icursor.png");
  logo = loadImage("logo.png");
  minim = new Minim(this);
  sound1 = minim.loadSample("sound1.wav", 2048);
  sound2 = minim.loadSample("sound2.wav", 2048);
  sound3 = minim.loadSample("sound3.wav", 2048);
  sound4 = minim.loadSample("sound4.wav", 2048);
  sound5 = minim.loadSample("sound5.wav", 2048);
  minim.debugOn();
  in = minim.getLineIn(Minim.STEREO, width);

  mt=new Mtoggles(width/27.32, width/13.66, width/9.1, width/6.83, width/5.464, height/9.6, 20, 0, 0, 0, 0, 0, 120, 120, 120, 120, 120);
  nt=new Ntoggles(width/3.04, width/2.5, width/2.1, width/1.82, width/1.6, height/9.6, 20, 0, 0, 0, 0, 0, 120, 120, 120, 120, 120);
  ct=new Ctoggles(width/1.33, height/9.6, 20, 0, 0);

  for (int i=0; i<num1; i++) {
    m1[i]=new module1(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
  for (int i=0; i<num2; i++) {
    m2[i]=new module2(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
  for (int i=0; i<num3; i++) {
    m3[i]=new module3(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
  for (int i=0; i<num4; i++) {
    m4[i]=new module4(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
  for (int i=0; i<num5; i++) {
    m5[i]=new module5(width/2, height/2, 
    random(-random(5, 10), random(5, 10)), 
    random(-random(5, 10), random(5, 10)), 
    random(30, 100), random(255), random(255), random(255));
  }
}

void draw() {
  background(mainCW);
  noFill();
  stroke(120);
  strokeWeight(3);
  for (int i = 0; i < in.bufferSize() - 1; i+=10) {
    rect(i, height/2+in.right.get(i)*200, 2+in.right.get(i)*200, 2+in.right.get(i)*200);
  }
  mt.update();
  mt.display();
  nt.update();
  nt.display();
  ct.update();
  ct.display();
  image(ic, mouseX, mouseY);
  image(logo, width/27.32, height/1.12);
}

void mousePressed() {
  nt.changeModule();
  mt.changeModule();
  ct.changeModule();
  if (mouseButton==RIGHT) {
    stroke(mainCB);
    strokeWeight(10);
    noFill();
    ellipse(width/2, height/2, 300, 300);
    for (int i=0; i<num1; i++) {
      m1[i]=new module1(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
    for (int i=0; i<num2; i++) {
      m2[i]=new module2(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
    for (int i=0; i<num3; i++) {
      m3[i]=new module3(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
    for (int i=0; i<num4; i++) {
      m4[i]=new module4(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
    for (int i=0; i<num5; i++) {
      m5[i]=new module5(width/2, height/2, 
      random(-random(5, 10), random(5, 10)), 
      random(-random(5, 10), random(5, 10)), 
      random(30, 100), random(255), random(255), random(255));
    }
  }
}

void stop() {
  in.close();
  sound1.close();
  sound2.close();
  sound3.close();
  minim.stop();
  super.stop();
}

